% CODING_LENGTH_HUFFMAN code the the group membership of a set of samples 
% within a clustering using an optimal Huffman code.
%
%   sampleCount is the number of samples in the group.
%
%   totalSampleCount is the number of samples in the entire dataset.
%
%   codingLength is the number of bits needed to represent the group
%   membership of the samples in this group using an optimal Huffman code.
%
%
%Authors: Shankar Rao
%Contact: Shankar Rao <srrao@illinois.edu>
%
%(c) Copyright. University of Illinois at Urbana-Champaign. 
%               University of California, Berkeley. 2009.
%
%
%Notice: The packages should NOT be used for any commercial purposes
%without direct consent of their author(s). The authors are not responsible
%for any potential property loss or damage caused directly or indirectly by
%the usage of the software.
function codingLength = coding_length_huffman(sampleCount, totalSampleCount)

codingLength = -sampleCount*log2(sampleCount/totalSampleCount);