function pixelIndices=find_interior_pixels(img, id, windowSize);
% pixelIndices=find_interior_pixels(img,id,ws)
%
% Returns an array of the window centroids which
% only contain pixels of the group "id"
%
% img     A matrix indexed as img(i,j) containing integer values
%         indicating group ID of each point
% id      The group id that we would like to analyze
% ws      The window size (e.g. ws=15 means 15*15 windows)
% pixelIndices   The linear indices of the interior pixels in this region
%
%Authors: Hossein Mobahi, Shankar Rao
%Contact: Shankar Rao <srrao@illinois.edu>
%(c) Copyright. University of Illinois at Urbana-Champaign. 2008.
%               University of California, Berkeley. 2008.
%
%
%Notice: The packages should NOT be used for any commercial purposes
%without direct consent of their author(s). The authors are not responsible
%for any potential property loss or damage caused directly or indirectly by
%the usage of the software.
%

pixelIndices = find(conv2(double(img==id), ones(windowSize), 'same')==(windowSize*windowSize));

% I=[]; J=[];
% 
%     for j=1+(ws-1)/2:size(img,2)-(ws-1)/2
% for i=1+(ws-1)/2:size(img,1)-(ws-1)/2
%         ISINTERIOR=true;
%         for ii=-(ws-1)/2:(ws-1)/2
%             for jj=-(ws-1)/2:(ws-1)/2
%                 if img(i+ii,j+jj)~=id
%                     ISINTERIOR=false;
%                     break;
%                 end
%                 if ~ISINTERIOR
%                     break;
%                 end
%             end
%         end
%         %ISINTERIOR
%         if ISINTERIOR
%             I=[I; i];
%             J=[J; j];
%         end
%     end
% end
