function [edgeGradient boundaryPixels] = obtain_boundary_gradient(pixelLabels, regionIndex1, regionIndex2, edgeImageX, edgeImageY)



[freqs directions differences startPositions] = adaptive_chain_code(pixelLabels==regionIndex1);
codebook = [ 0 1; -1 1; -1 0; -1 -1; 0 -1; 1 -1; 1 0; 1 1];
tangentVectors = cell(length(directions),1);
curveCount = 0;
boundaryPixels = {};
for boundaryIndex = 1:length(directions),
    if isempty(directions{boundaryIndex}),
        continue;
    end
    allTangentVectors = codebook(directions{boundaryIndex}+1,:);
    currentBoundary = cumsum([startPositions(boundaryIndex,:) ; allTangentVectors]);
    isNewCurve = true;
    for boundaryIndex2 = 1:size(currentBoundary,1),
        % get pixel coordinates of each of the 4-neighbors of this pixel
        neighborPixels = repmat(currentBoundary(boundaryIndex2,:),4,1) + [1  0; -1 0; 0 1; 0 -1];
        % convert to linear indices
        neighborIndices = sub2ind(size(pixelLabels), neighborPixels(:,1), neighborPixels(:,2));
        

        if any(pixelLabels(neighborIndices) == regionIndex2),
            if ~isNewCurve,
                boundaryCount = boundaryCount + 1;
            else
                isNewCurve = false;
                curveCount = curveCount + 1;
                boundaryCount = 1;
                tangentVectors{curveCount} = [];
            end
            boundaryPixels{curveCount}(boundaryCount,:) = currentBoundary(boundaryIndex2,:);
            if boundaryIndex2 ~= size(currentBoundary,1),
            tangentVectors{curveCount}(boundaryCount,:) = allTangentVectors(boundaryIndex2,:);
            end
        else
            if ~isNewCurve && ~isempty(tangentVectors{curveCount}),
                tangentVectors{curveCount}(end,:) = [];
            end
            isNewCurve = true;
        end
    end
end
if isempty(boundaryPixels)
    edgeGradient = {};
    boundaryPixels = [];
    return;
end
for curveIndex = 1:length(boundaryPixels),
    boundaryIndices{curveIndex} = sub2ind(size(pixelLabels), boundaryPixels{curveIndex}(:,1), boundaryPixels{curveIndex}(:,2));
    edgeGradient{curveIndex} = zeros(1,size(tangentVectors{curveIndex},1));
    for i=1:size(tangentVectors{curveIndex},1)
        edgeDerivative = [mean(edgeImageX(boundaryIndices{curveIndex}(i:i+1))); ...
            mean(edgeImageY(boundaryIndices{curveIndex}(i:i+1)))];
        normalVector = [-tangentVectors{curveIndex}(i,2) tangentVectors{curveIndex}(i,1)];
        normalVector = normalVector / norm(normalVector);
        edgeGradient{curveIndex}(i) = normalVector*edgeDerivative;
    end
end