% TEST_TEXTURE_SEG
%
% A testing program for the lossy coding based image segmentor. 
%
%Authors: Shankar Rao, Hossein Mobahi, Allen Yang
%Contact: Shankar R. Rao <srrao@illinois.edu>
%
%(c) Copyright. University of Illinois, 2008.
%
%Notice: The packages should NOT be used for any commercial purposes
%without direct consent of the authors.
img1 = imread('198023.jpg');

epsilon = 100;
[labels, syntheticImage, X] = texture_seg(img1, ...
    'epsilon', epsilon, ...
    'superpixelFilename', '198023-superpixels.mat', ...
    'featuresFilename', '198023-features.mat');

load('198023.mat');

RI = 0;
VOI = 0;
subjectCount = length(imageLabelCell);
for subjectIndex = 1:subjectCount,
    RI = RI + Rand_index(labels, imageLabelCell{subjectIndex});
    VOI = VOI + VoI_index(labels, imageLabelCell{subjectIndex});
end
RI = RI / subjectCount;
VOI = VOI / subjectCount;

fprintf('PRI = %f, VoI = %f\n', RI, VOI);

segImage = segmented_image(syntheticImage, labels);

subplot(121)
imshow(img1)
xlabel('Original Image')
subplot(122)
imshow(segImage);
xlabel('Segmentation Result')
